diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -2439,456 +2697,852 @@
   case 0x03b:
     {
       // LDRH Rd, [Rn], -Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base) {
         address -= offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x05b:
   case 0x07b:
     {
       // LDRH Rd, [Rn], #-offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base) {
         address -= offset;
         reg[base].I = address;
       }
+      clockTicks=0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x09b:
   case 0x0bb:
     {
       // LDRH Rd, [Rn], Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base) {
         address += offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x0db:
   case 0x0fb:
     {
       // LDRH Rd, [Rn], #offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base) {
         address += offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x11b:
     {
       // LDRH Rd, [Rn, -Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x13b:
     {
       // LDRH Rd, [Rn, -Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x15b:
     {
       // LDRH Rd, [Rn, -#offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x17b:
     {
       // LDRH Rd, [Rn, -#offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x19b:
     {
       // LDRH Rd, [Rn, Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1bb:
     {
       // LDRH Rd, [Rn, Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1db:
     {
       // LDRH Rd, [Rn, #offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1fb:
     {
       // LDRH Rd, [Rn, #offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = CPUReadHalfWord(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x01d:
   case 0x03d:
     {
       // LDRSB Rd, [Rn], -Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base) {
         address -= offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x05d:
   case 0x07d:
     {
       // LDRSB Rd, [Rn], #-offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base) {
         address -= offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x09d:
   case 0x0bd:
     {
       // LDRSB Rd, [Rn], Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base) {
         address += offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x0dd:
   case 0x0fd:
     {
       // LDRSB Rd, [Rn], #offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base) {
         address += offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x11d:
     {
       // LDRSB Rd, [Rn, -Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x13d:
     {
       // LDRSB Rd, [Rn, -Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x15d:
     {
       // LDRSB Rd, [Rn, -#offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x17d:
     {
       // LDRSB Rd, [Rn, -#offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x19d:
     {
       // LDRSB Rd, [Rn, Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1bd:
     {
       // LDRSB Rd, [Rn, Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1dd:
     {
       // LDRSB Rd, [Rn, #offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1fd:
     {
       // LDRSB Rd, [Rn, #offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s8)CPUReadByte(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x01f:
   case 0x03f:
     {
       // LDRSH Rd, [Rn], -Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base) {
         address -= offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x05f:
   case 0x07f:
     {
       // LDRSH Rd, [Rn], #-offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base) {
         address -= offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x09f:
   case 0x0bf:
     {
       // LDRSH Rd, [Rn], Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base) {
         address += offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x0df:
   case 0x0ff:
     {
       // LDRSH Rd, [Rn], #offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base) {
         address += offset;
         reg[base].I = address;
       }
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x11f:
     {
       // LDRSH Rd, [Rn, -Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x13f:
     {
       // LDRSH Rd, [Rn, -Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x15f:
     {
       // LDRSH Rd, [Rn, -#offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x17f:
     {
       // LDRSH Rd, [Rn, -#offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x19f:
     {
       // LDRSH Rd, [Rn, Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1bf:
     {
       // LDRSH Rd, [Rn, Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1df:
     {
       // LDRSH Rd, [Rn, #offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
   case 0x1ff:
     {
       // LDRSH Rd, [Rn, #offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 3 + CPUUpdateTicksAccess16(address);
       reg[dest].I = (s16)CPUReadHalfWordSigned(address);
       if(dest != base)
         reg[base].I = address;
+      clockTicks = 0;
+      if(dest == 15) {
+        reg[15].I &= 0xFFFFFFFC;
+        armNextPC = reg[15].I;
+        reg[15].I += 4;
+        ARM_PREFETCH;
+        clockTicks += 2 + dataTicksAccessSeq32(address) + dataTicksAccessSeq32(address);
+      }
+      clockTicks += 3 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
     }
     break;
     LOGICAL_DATA_OPCODE_WITHOUT_base(OP_EOR,  OP_EOR, 0x020);
@@ -2896,25 +3550,28 @@
   case 0x029:
     {
       // MLA Rd, Rm, Rs, Rn
+      clockTicks = 2;
       int dest = (opcode >> 16) & 0x0F;
       int mult = (opcode & 0x0F);
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
       reg[dest].I = reg[mult].I * rs + reg[(opcode>>12)&0x0f].I;
-      if(((s32)rs)<0)
-        rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 3;
+        clockTicks += 0;
       else if ((rs & 0xFFFF0000) == 0)
-        clockTicks += 4;
+        clockTicks += 1;
       else if ((rs & 0xFF000000) == 0)
-        clockTicks += 5;
+        clockTicks += 2;
       else
-        clockTicks += 6;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
   case 0x039:
     {
       // MLAS Rd, Rm, Rs, Rn
+      clockTicks = 2;
       int dest = (opcode >> 16) & 0x0F;
       int mult = (opcode & 0x0F);
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
@@ -2924,13 +3581,16 @@
       if(((s32)rs)<0)
         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 3;
+        clockTicks += 0;
       else if ((rs & 0xFFFF0000) == 0)
-        clockTicks += 4;
+        clockTicks += 1;
       else if ((rs & 0xFF000000) == 0)
-        clockTicks += 5;
+        clockTicks += 2;
       else
-        clockTicks += 6;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
     ARITHMETIC_DATA_OPCODE(OP_SUB,  OP_SUB, 0x040);
@@ -2942,6 +3602,7 @@
   case 0x089:
     {
       // UMULL RdLo, RdHi, Rn, Rs
+      clockTicks = 2;
       u32 umult = reg[(opcode & 0x0F)].I;
       u32 usource = reg[(opcode >> 8) & 0x0F].I;
       int destLo = (opcode >> 12) & 0x0F;         
